#ifndef DISKIO_H
#define DISKIO_H

#define DEFAULT_SECTOR_SIZE	512
#define DEFAULT_SECTOR_SHIFT	9

typedef unsigned long sector_t;

typedef struct {
    char *devname;
    int fd;
    int sector_size;
    int sector_shift;
    sector_t nsect;
} DISKDEV;

DISKDEV *dev_open(char *devname, int readonly);
int dev_close(DISKDEV *dev);
int reread_partition(DISKDEV *dev);
int read_sector(DISKDEV *dev, sector_t sect, unsigned char *buf, int nsect);
int write_sector(DISKDEV *dev, sector_t sect, unsigned char *buf, int nsect);

#endif /* DISKIO_H */
