#ifndef PS2PART_H
#define PS2PART_H

#include <linux/types.h>

#define PS2_PART_VERSION	0x00000002
#define PS2_PART_MAGIC		0x00415041
#define PS2_MBR_MAGIC		"Sony Computer Entertainment Inc."

#define PS2_ID_MBR		"_mbr"
#define PS2_ID_TMP		"_tmp"
#define PS2_ID_EMPTY		"_empty"

#define PS2_PART_NID		32
#define PS2_PART_NPASSWD	8
#define PS2_PART_NNAME		128
#define PS2_PART_MAXSUB		64
#define PS2_PART_MAXSUB_SHIFT	6

#define PS2_PART_FLAG_SUB	0x0001

#define PS2_PART_DATE_TZONE	(9 * 60 * 60)
#define PS2_PART_MINSIZE	0x00040000

#define MODVER	0x0102

#define LINUX_PART_MAX		63
#define LINUX_ID		"__linux.%d"

struct ps2_part_date {
    unsigned char rsvd;
    unsigned char sec, min, hour, day, month;
    unsigned short year;
} __attribute__ ((packed));

struct ps2_part_subpart {
    __u32 start;
    __u32 nsector;
} __attribute__ ((packed));

struct ps2_part_mbr {
    char magic[32];
    __u32 version;
    __u32 nsector;
    struct ps2_part_date date;
    __u32 osd_start;
    __u32 osd_count;
    char rsvd[200];
} __attribute__ ((packed));

struct ps2_partition {
    __u32 sum;
    __u32 magic;
    __u32 next;
    __u32 prev;
    char id[PS2_PART_NID];
    char rpwd[PS2_PART_NPASSWD];
    char fpwd[PS2_PART_NPASSWD];
    __u32 start;
    __u32 nsector;
    __u16 fstype;
    __u16 flag;
    __u32 nsub;
    struct ps2_part_date date;
    __u32 main;
    __u32 number;
    __u32 modver;
    __u32 rsvd[7];
    char name[PS2_PART_NNAME];
    struct ps2_part_mbr mbr;
    struct ps2_part_subpart subs[PS2_PART_MAXSUB];
} __attribute__ ((packed));

#endif /* PS2PART_H */
